.include "m16def.inc"

;--------------.device atmega16 - initializare --------------------
.equ 	op10 	= 0x60
.equ 	op11 	= 0x61
.equ 	op12 	= 0x62
.equ 	codop 	= 0x63
.equ 	op20	= 0x64
.equ 	op21 	= 0x65
.equ 	op22 	= 0x66
.equ 	sgn  	= 0x67
.equ 	cerr 	= 0x68
.equ 	abuf  	= 0x69
.equ 	abufe 	= abuf + 7 	;70
.equ 	tmp0 	= 0x71
.equ 	tmp1 	= 0x72
.equ 	tmp2 	= 0x73
.equ 	ncif	= 0x74
.equ 	level 	= 0x75
.equ 	codtmp 	= 0x76
.equ 	fer 	= 0x77
.equ 	mdate 	= 0x100
.org $0
jmp init
.org $1a

.org $60
init:
	cli			; turn off the interruption flags
	ldi 	r16,0x03	; LoaD Immediate 
	out 	$3e,r16
	ldi 	r16,0x5f
	out 	0x3d,r16
	ser 	r16		; sets all the bits to 1
	out 	DDRD,r16
	ldi 	r16,0x03
	out 	DDRC,r16
	clr 	r16		; sets all the bits to 0
	out 	DDRB,r16
	out	PORTC,r16
	out	PORTD,r16
	call 	inid 		; initializare lcd
	call	intst
	call 	clrd 		; stergere lcd

main:
	clr 	r16
	sts 	op10,r16	; stoare direct
	sts 	op11,r16
	sts 	op12,r16
	call	lcd
	ldi 	r27,1
	clr 	r26
	sts 	level,r26

m100:

	m21: 
		call 	inpn		;.. x1

m101:
	call 	ptx1

m12:
	call 	ldopx 		; x10
	lds 	r17,codop
	cpi 	r17,18 		; c compare with immediate
	breq	main		; brench if equal
	cpi 	r17,17 		; =
	brne 	m102		; brench if not equal
	sts 	codtmp,r17
	lds 	r16,level	; load direct
	tst 	r16		; test for 0 or negativ
	breq 	m100
	call 	stop12
	call 	declev 		;l-1
	call 	ldc1
	cpi 	r17,14 		;(
	breq 	m101
	call 	ldc2
	cpi 	r17,14 		;(
	breq 	m203
	jmp 	m301

m102:
	cpi 	r17,14 		;(
	brlo 	m200 		; op+../ branch if lower
	breq 	m103 		;(
	cpi 	r17,15 		;)
	breq 	m106
	rjmp 	main 		;... relative jump

m103:
	call 	inclev
	jmp 	m100

m106:
	call 	stop12
	lds 	r16,level
	tst 	r16
	breq 	m200
	call 	declev
	call 	ldc2
	cpi 	r17,14 		;(
	brne 	m104 		; m21
	call 	inpcod
	jmp 	m203

m105:
	call 	inpcod
	jmp 	m101

m104:
	call 	ldc1
	cpi 	r17,14 		;(
	breq 	m105
	jmp 	m301

m200:
	m11:
	call 	inpn		;....x2

m203:
	call 	ptx2
	call 	ldopx ;
	call 	ldc2 		;c2
	cpi 	r17,14 		;(
	brne 	m204
	call 	inclev
	jmp 	m100
	
m204:
	cpi 	r17, 15 		;)
	brne 	m211
	call 	stop12
	call 	exop1 		; op1 = rez
	brne 	eroare
	lds 	r16, level
	tst 	r16
	brne 	m206		;x1 
	jmp 	m21

m206:
	call 	declev 		;l-1
	call 	ldc1
	cpi 	r17, 14 	;(
	breq 	m201
	call 	ldc2
	cpi 	r17,14 		;(
	breq 	m202
	jmp 	m300

m202:
	call 	inpcod
	jmp 	m203
	
m201:
	call 	inpcod
	jmp 	m101

m211:
	cpi 	r17,17 		; =
	breq 	m205
	cpi 	r17,18 		; c
	brne 	m210
	jmp 	main

m210:
	andi 	r17,0xfe	; logical AND with immediate
	cpi 	r17,10 		; +-
	breq 	m207
	cpi 	r17,12 		; */
	breq 	m209 		;
	jmp 	m11

eroare:
	call 	afer
	call 	inpcod
	call 	clrd
	clr 	r16
	sts 	fer,r16		; store immediate
	jmp 	main

m205:
	call 	exop1
	brne 	eroare
	lds 	r16,level
	tst 	r16		; test if zero or negative
	brne 	m206
	jmp 	m100 		; par(

m207:
	call 	exop1
	brne 	eroare
	call 	ptx1
	call 	ldopx
	jmp 	m100

m209:
	call 	ldc1
	andi 	r17,0xfe 	; +-
	cpi 	r17,10
	breq 	m300
	jmp 	m207

m300:
	call 	inpn

m301:
	call 	ptx3
	call 	ldopx
	call 	stop23
	lds 	r16,sgn 	; c3
	sts 	codtmp,r16
	call 	exec
	lds 	r16,cerr
	tst 	r16
	brne 	eroare
	lds 	r17,codtmp 	; c3-c2
	sts 	codop,r17
	jmp 	m203

exop1:
	call 	ldc2
	sts 	codtmp,r17
	call 	stop12 ;
	call 	exec
	lds 	r17,codtmp
	sts 	codop,r17 	; c1 = c2
	lds 	r16,fer
	tst 	r16
	ret 			; subroutine return

stop12:
	call 	ptx1

st122:
	mov 	r18,r26
	clr 	r29
	ldi 	r28,op10
	ldi 	r17,8

st121:
	ld 	r16,x+
	st 	y+,r16
	dec 	r17
	brne 	st121		; decrement register
	lds 	r16,sgn
	sts 	codtmp,r16 	; c2
	mov 	r26,r18 	; x10
	ret
	
stop23:
	call 	ptx2
	jmp 	st122
	
exec:
	push 	r26
	push 	r27
	lds 	r16,codop
	cpi 	r16,10
	breq 	a10
	cpi 	r16,11
	breq 	a11
	cpi 	r16,12
	breq 	a12
	cpi 	r16,13
	breq 	a13

finexe:
	pop 	r27
	pop 	r26
	ret

a10:
	call 	adun

a20:
	lds 	r16,cerr
	lds	r17 ,fer
	or 	r17,r16
	sts 	fer,r17
	call 	lcd
	jmp 	finexe

a11:
	call 	ldop
	com 	r19		; one's complement
	com 	r20
	com 	r21
	clr 	r22
	sec
	adc 	r19,r22		; add with carry
	adc 	r20,r22
	adc 	r21,r22
	add 	r16,r19		; add without carry
	adc 	r17,r20
	adc 	r18,r21
	call	stop
	jmp 	a20

a12:
	call	mul0
	jmp 	a20

a13:
	call	div
	jmp 	a20

inclev:
	lds	r20,level
	inc 	r20

aflev:
	ldi 	r19,0x81
	tst 	r20
	breq 	lev2
	ldi 	r18,0x28
	call 	d1c
	clr 	r21
	ldi 	r23,10
	mov 	r22,r20
	sub 	r22,r23
	brcs 	lev1		; branch if carry set
	inc 	r21
	sub 	r22,r23
	brcs 	lev1
	inc 	r21

lev1:
	ldi 	r18,0x30
	add 	r18,r21
	call 	d1c
	ldi 	r18,0x30
	add 	r22,r23
	add 	r18,r22
	call 	d1c
	ldi 	r18,0x29
	call 	d1c

lev3:
	sts	level,r20
	tst 	r20
	ret

lev2:
	ldi 	r18,0x20
	call 	d1c
	call 	d1c
	call 	d1c
	call 	d1c
	rjmp 	lev3
	
declev:
	lds 	r20,level
	tst 	r20
	breq 	aflev
	dec 	r20
	jmp 	aflev

ldopx:
	clr 	r29
	ldi 	r28,op10
	ldi 	r16,4

ldx1:
	ld 	r17,y+
	st 	x+,r17
	dec 	r16
	brne 	ldx1
	ret

ptx1:
	lds 	r26,level

ptx10:
	lsl	r26
	lsl 	r26
	lsl 	r26
	ldi 	r27,1
	ret

ptx2:
	call 	ptx1
	ori 	r26,4		; logical AND with immediate
	ret
	
ptx3:
	ld 	r26,level
	inc 	r26
	jmp 	ptx10

ldc1:
	call	 ptx2
ldc10:
	dec 	r26
	ld 	r17,x
	ret

ldc2:
	call	ptx3
	jmp 	ldc10

inpn:
	push 	r26
	push 	r27
	call 	intst
	cpi 	r17,10
	brge 	m6		; branch if greater then or equal
	clr 	r16
	sts 	op10,r16
	sts 	op11,r16
	sts 	op12,r16
	sts 	sgn,r16
	ldi 	r16,7
	mov 	r14,r16

m3:
	mov 	r15,r17
	call 	mul10
	sts 	op20,r15
	clr 	r16
	sts 	op21,r16
	sts	op22,r16
	call 	adun
	call 	lcd
	dec 	r14
	breq 	m2
	call 	intst
	cpi 	r17,10
	brge 	m6
	rjmp 	m3

m2:
	call	 intst

m6:
	cpi	r17,16 		; +/-
	breq 	m1
	cpi 	r17,10
	brlo 	m2
	sts 	codop,r17
	pop 	r27
	pop 	r26
	ret 

m1:
	call 	negop1
	call 	lcd
	jmp 	m2
	
negop1:
	ser 	r16		; set register
	sts 	op20,r16
	sts 	op21,r16
	sts 	op22,r16
	call 	mul0
	ret

inpcod:
	call 	lcd

inpc1:
	call 	intst
	cpi 	r17,10
	brlo 	inpc1		; branch if lower
	sts 	codop,r17
	ret

lcd:	
	call 	con10c
	call 	afis
	call 	disp
	ret

intst:
	call 	scantst
	cpi 	r17,0xff
	brne 	intst
	call 	wait 	;25ms
	call 	wait
	call 	wait

i01:
	call	scantst
	cpi 	r17,0xff
	breq 	i01
	call 	wait
	call 	wait
	call 	wait
	ret
	
afer:
	ldi 	r19,0x81
	ldi 	r18,0x45
	call 	d1c
	ldi 	r18,0x72
	call 	d1c
	ldi 	r18,0x6f
	call 	d1c
	ldi 	r18,0x61
	call 	d1c
	ldi 	r18,0x72
	call 	d1c
	ldi 	r18,0x65
	call 	d1c
	ret

clrb:
	push 	r26
	push 	r27
	clr 	r16
	ldi 	r17,8
	clr 	r27
	ldi 	r26,abuf

cb1:
	st 	x+,r16 		;0
	dec 	r17
	brne 	cb1		; store immediate
	pop 	r27
	pop 	r26
	ret

;----------------------- operatia de adunare -------------------
adun:
	call 	ldop
	mov 	r23,r18
	eor 	r23,r21		; logical exclusive or
	add 	r16,r19
	adc 	r17,r20
	adc 	r18,r21
	com 	r23		; one's commplement
	andi 	r23,0x80	; logical AND with immediate
	breq 	ad1
	mov 	r23,r21
	eor 	r23,r18

ad1:
	sts 	cerr,r23
	call 	stop
	ret

;------------------------ operatia de impartiere ----------------
div:
	clr 	r27
	ldi 	r26,op10
	call 	ldop
	call 	div24u
	call 	stop
	ret

mul10:
	clr 	r16
	sts 	op22,r16
	sts 	op21,r16
	ldi 	r16,10
	sts 	op20,r16
	call 	mul0
	ret

mul0:
	clr	 r27
	ldi 	r26,op10

mul2:
	call 	ldop
	call 	testsgn
	clr 	r22
	clr 	r23
	clr 	r24
	clr 	r10
	clr 	r11
	clr 	r12
	ldi 	r25,24
	
mul6:
	ror	r18		; rotate right through carry
	ror 	r17
	ror 	r16
	brcc 	mul5		; branch if carry cleared
	tst 	r22		; test if zero or negative
	brne 	err
	tst	r23
	brne 	err
	tst 	r24
	brne 	err
	add 	r10,r19
	adc 	r11,r20
	adc 	r12,r21
	brcs 	err		; branch if carry set

mul5:
	lsl 	r19
	rol 	r20		; rotate left through carry
	rol 	r21
	rol 	r22
	rol 	r23
	rol 	r24
	dec 	r25
	brne 	mul6
	mov 	r16,r10
	mov 	r17,r11
	mov 	r18,r12
	call 	refsgn
	call 	stop
	
err:
	sts 	cerr,r25
	ret

ldop:
	push	 r26
	push	 r27
	ld 	r16,x+
	ld 	r17,x+
	ld 	r18,x+
	ld  	r19,x+
	ld 	r19,x+
	ld 	r20,x+
	ld 	r21,x+
	pop 	r27
	pop 	r26
	ret

stop:
	push	 r26
	push	 r27
	clr	 r27
	ldi	 r26,op10
	st	 x+,r16
	st	 x+,r17
	st	 x+,r18
	pop 	r27
	pop 	r26
	ret
	
div24u:
	call 	testsgn
	ldi	r25,24 
	mov 	r22,r19
	or  	r22,r20
	or  	r22,r21
	breq 	erd
	clr	r10 
	clr	r11 
	clr	r12 
	lsl	r16 
	rol	r17 		;
	rol	r18 
	rol	r10 
	rol	r11 		;
	rol	r12 
	cp	r10,r19 
	cpc	r11,r20 
	cpc	r12,r21 
	brcs	PC+5	
	inc	r16 	
	sub	r10,r19 
	sbc	r11,r20 	; substract with carry
	sbc	r12,r21 	; rest
	dec	r25 
	brne	PC-15		
	call 	refsgn

erd:
	sts 	cerr,r25
	ret

testsgn:
	mov 	r25,r18
	eor 	r25,r21 ;s
	andi 	r25,0x80
	sts 	sgn,r25
	ldi 	r22,0x80
	and 	r22,r18
	breq 	te1
	call 	neg1

te1:
	ldi 	r22,0x80
	and 	r22,r21
	breq 	te2
	call 	neg2

te2:
	ret

refsgn:
	lds 	r22,sgn
	andi 	r22,0x80
	breq 	re1
	com 	r16
	com 	r17
	com 	r18
	clr 	r23
	sec			; set carry flag
	adc 	r16,r23
	adc 	r17,r23
	adc 	r18,r23
	ori 	r18,0x80

re1:
	ret

con10c:
	push 	r26
	push 	r27
	clr 	r27
	ldi 	r26,op10
	call 	ldop
	ldi 	r19,0x80
	and 	r19,r18
	sts 	abuf,r19
	breq 	con1
	call 	neg1

con1:
	ldi 	r28,7
	mov 	r15,r28
	clr 	r29
	ldi 	r28,abufe

con2:
	clr 	r21
	clr 	r20
	ldi 	r19,10
	call 	div24u
	st 	y,r10
	dec 	r28
	dec 	r15
	brne 	con2
	pop 	r27
	pop 	r26
	ret

neg1:
	com 	r16
	com 	r17
	com 	r18
	clr 	r22
	sec
	adc 	r16,r22
	adc 	r17,r22
	adc 	r18,r22
	cbr 	r18,0x80	; clear bits in register
	ret

neg2:
	com 	r19
	com 	r20
	com 	r21
	clr 	r22
	sec
	adc 	r19,r22
	adc 	r20,r22
	adc 	r21,r22
	cbr 	r21,0x80
	ret

afis:
	push 	r26
	push 	r27
	ldi 	r26,abuf
	clr 	r27
	ldi 	r20,0x20
	ld 	r19,x
	st 	x,r20
	andi 	r19,0x80
	breq 	af1
	ldi 	r20,0x2d

af1:
	inc 	r26
	ldi 	r17,6
	ldi 	r16,0x20

af2:
	ld 	r18,x
	tst 	r18
	brne 	af3
	st 	x+,r16
	dec 	r17
	brne 	af2

af3:
	dec 	r26
	st 	x+,r20
	ldi 	r16,0x30
	inc 	r17

af4:
	ld 	r18,x
	add 	r18,r16
	st 	x+,r18
	dec 	r17
	brne 	af4
	pop 	r27
	pop 	r26
	ret

disp:
	push 	r26
	push 	r27
	ldi 	r26,abuf
	clr 	r27
	ldi 	r20,8
	ldi 	r19,0xc0 	;8 ;set ddra adr 08

dis1: 
	ld 	r18,x+ 		; incarca chr in r18
	call	d1c  		; scrie 1 caracter pe lcd la adr r18,chr in r19
	dec 	r20 		; 8 digit contor
	brne 	dis1
	pop 	r27
	pop 	r26
	ret

d1c:
	mov	 r16,r19 	; salveaza adresa mem lcd in r16
	call 	ena  		; out la lcd
	sbi 	PORTC,1 	; set pin rs la lcd
	mov 	r16,r18 	; incarca chr 
	call 	ena    		; out la lcd
	cbi 	PORTC,1 	; reset pin rs la lcd
	inc 	r19     	; increm.adresa mem 
	ret
	
	;.equ en = PORTC,0
	;.equ rs = PORTC,1
	;.equ rw = PORTC,2

;------------------------ initializare LCD ---------------------------
inid:
	call 	clrd 		; clear lcd
	ldi 	r16,4     	; entry set mode,disp not shift
	call 	ena
	ldi 	r16,0x0c 	; display-on
	call 	ena
	ldi 	r16,0x38 	; function set = 8bit,2line
	call 	ena
	ldi 	r19,0x80 	; set adresa ddram disp
	ldi 	r18,0x43 	; scrie lcd
	call 	d1c
	ldi 	r18,0x72
	call 	d1c
	ldi 	r18,0x69
	call 	d1c
	ldi 	r18,0x73
	call 	d1c
	ldi 	r18,0x74
	call 	d1c
	ldi	 r18,0x69
	call 	d1c
	ldi 	r18,0x6e
	call 	d1c
	ldi 	r18,0x61
	call 	d1c
	ldi 	r19,0xc0

	ldi 	r18,0x49
	call 	d1c
	ldi 	r18,0x6f
	call 	d1c
	ldi 	r18,0x72
	call 	d1c
	ldi 	r18,0x64
	call 	d1c
	ldi 	r18,0x61
	call 	d1c
	ldi 	r18,0x63
	call 	d1c
	ldi 	r18,0x68
	call 	d1c
	ldi 	r18,0x69
	call 	d1c
	ret

wait:
	push 	r16
	push 	r17
	ldi 	r17,0xff

wa1:
	dec 	r16
	brne 	wa1
	dec 	r17
	brne 	wa1
	pop 	r17
	pop 	r16
	ret

clrd:
	clr 	r16
	out 	PORTC,r16
	inc 	r16 		; clr
	call 	ena
	clr 	r17

cl1:
	ldi 	r18,10

cl2:
	nop			; no operation
	nop
	dec 	r18
	brne 	cl2
	dec 	r17
	brne 	cl1
	ret

ena:
	out 	PORTD,r16 	; out d0-7 lcd
	nop
	nop
	nop
	nop
	nop
	sbi 	PORTC,0 	; set pin enable lcd
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	cbi 	PORTC,0 	; reset pin enable lcd
	ldi 	r17,120

e1:
	nop
	dec 	r17
	brne 	e1
	ret

sc:
	out 	PORTD,r16
	ldi 	r17,10
	
sc1:
	dec 	r17
	brne 	sc1
	in 	r18,PINC

sc3:
	ret

;----------------------- setare tastatura --------------------
scantst:
	ldi 	r16,4 		; l1
	call 	sc
	ldi 	r17,16 		; +/-
	lsl 	r18
	brcs 	sc3
	ldi 	r17,0 		; 0
	lsl 	r18
	brcs 	sc3
	ldi 	r17,17 		; =
	lsl 	r18
	brcs 	sc2
	ldi 	r17,13 		; /
	lsl 	r18
	brcs 	sc2

	lsl 	r16 		; l2
	call 	sc
	ldi 	r17,7 		; 7
	lsl 	r18
	brcs 	sc2
	ldi 	r17,8 		; 8
	lsl 	r18
	brcs 	sc2
	ldi 	r17,9 		; 9
	lsl 	r18
	brcs 	sc2
	ldi 	r17,12 		; *
	lsl 	r18
	brcs 	sc2

	lsl 	r16 		; l3
	call 	sc
	ldi 	r17,4 		; 4
	lsl 	r18
	brcs 	sc2
	ldi 	r17,5 		; 5
	lsl 	r18
	brcs 	sc2
	ldi 	r17,6 		; 6
	lsl 	r18
	brcs 	sc2
	ldi 	r17,11 		; -
	lsl 	r18
	brcs 	sc2

	lsl 	r16 		; l4
	call 	sc
	ldi 	r17,1 		; 1
	lsl 	r18
	brcs 	sc2
	ldi 	r17,2 		; 2
	lsl 	r18
	brcs 	sc2
	ldi 	r17,3 		; 3
	lsl 	r18
	brcs 	sc2
	ldi 	r17,10 		; +
	lsl 	r18
	brcs 	sc2

	lsl 	r16 		; l5
	call 	sc
	ldi 	r17,14 		; (
	lsl 	r18
	lsl 	r18
	brcs 	sc2
	ldi 	r17,15 		; )
	lsl 	r18
	brcs 	sc2
	ldi 	r17,18 		; C
	lsl 	r18
	brcs 	sc2
	ldi 	r17,0xff

sc2:
	ret
